﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using iTextSharp.text.html.simpleparser;
using iTextSharp.text.pdf;
using iTextSharp.text;
using System.IO;
using System.Windows.Media;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

namespace WatermarkTest
{
    public class WaterMark
    {
        public bool PDFWatermark(string inputfilepath, string outputfilepath, string modelPicName, string waterMarkName, float top, float left)
        {
            //throw new NotImplementedException();
            PdfReader pdfReader = null;
            PdfStamper pdfStamper = null;
            try
            {
                pdfReader = new PdfReader(inputfilepath);
                // 必须先加入资源 
                //BaseFont.AddToResourceSearch("iTextAsian.dll");
                //BaseFont.AddToResourceSearch("iTextAsianCmaps.dll");

                //"UniGB-UCS2-H" "UniGB-UCS2-V"是简体中文，分别表示横向字 和 纵向字 
                //"STSong-Light"是字体名称 
                //BaseFont baseFont = BaseFont.CreateFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);

                //BaseFont baseFont = BaseFont.CreateFont("C:/windows/fonts/simsun.ttc,1", BaseFont.IDENTITY_H, BaseFont.NOT_EMBEDDED);  

                int numberOfPages = pdfReader.NumberOfPages;

                iTextSharp.text.Rectangle psize = pdfReader.GetPageSize(1);

                float width = psize.Width;

                float height = psize.Height;

                pdfStamper = new PdfStamper(pdfReader, new FileStream(outputfilepath, FileMode.Create));

                PdfContentByte waterMarkContent;

                //水印图片
                iTextSharp.text.Image imageWaterMark = iTextSharp.text.Image.GetInstance(modelPicName);
                //imageWaterMark.GrayFill = 20;//透明度，灰色填充
                imageWaterMark.Rotation = 45;//旋转
                imageWaterMark.RotationDegrees = 45;//旋转角度
                imageWaterMark.SetAbsolutePosition(left, (height - imageWaterMark.Height) - top);
                //水印的位置 
                if (left < 0)
                {
                    left = width - imageWaterMark.Width + left;
                }

               
                int j = waterMarkName.Length;
                

                //每一页加水印,也可以设置某一页加水印 
                for (int i = 1; i <= numberOfPages; i++)
                {
                    int rise = 0; 
                    waterMarkContent = pdfStamper.GetUnderContent(i);
                    //图片水印
                    waterMarkContent.AddImage(imageWaterMark);
                    //文字水印
                    //waterMarkContent.BeginText();
                    //waterMarkContent.SetColorFill(BaseColor.CYAN);
                    //waterMarkContent.SetFontAndSize(baseFont, 50);
                    //// 设置水印文字字体倾斜 开始 
                    //if (j >= 15)
                    //{
                    //    waterMarkContent.SetTextMatrix(200, 120);
                    //    for (int k = 0; k < j; k++)
                    //    {
                    //        waterMarkContent.SetTextRise(rise);
                    //        char c = waterMarkName.ToCharArray()[k];
                    //        waterMarkContent.ShowText(c + "");
                    //        rise -= 20;
                    //    }
                    //}
                    //else
                    //{
                    //    for (float p = height; p > 50; p= p-50)
                    //    {
                    //        waterMarkContent.SetTextMatrix(150,p-50);
                    //        for (int k = 0; k < j; k++)
                    //        {
                    //            waterMarkContent.SetTextRise(rise);
                    //            char c = waterMarkName.ToCharArray()[k];
                    //            waterMarkContent.ShowText(c + "");
                    //            rise -= 20;
                    //        }
                    //    }
                    //}
                    //// 字体设置结束 
                    //waterMarkContent.EndText();
                    // 画一个圆 
                    // under.ellipse(250, 450, 350, 550); 
                    // under.setLineWidth(1f); 
                    // under.stroke(); 

                }
                //strMsg = "success";
                return true;
            }
            catch (Exception ex)
            {
                ex.Message.Trim();
                return false;
            }
            finally
            {

                if (pdfStamper != null)
                    pdfStamper.Close();

                if (pdfReader != null)
                    pdfReader.Close();
            }
        }


      


    }

    
}
